#ifndef MICROPHONE_H
#define MICROPHONE_H

#include <Arduino.h>
#include "Hardware.h"

namespace microphone {
  constexpr float VADC_REF = 2.4; // V
  constexpr uint16_t ADC_RES = 4096; // 12 bit ADC
  constexpr uint8_t MIC_REF_SPL = 94; // db SPL at 1 kHz sinus
  constexpr uint32_t US_TO_SEC = 1000000.0;
  
  constexpr uint8_t NUM_OF_RECORDINGS = 10;
  constexpr uint16_t NUM_OF_SAMPLES = 1040;
  constexpr uint16_t SAMPLE_RATE = 8192;
  constexpr uint8_t NUM_OF_FREQUENCY_BINS = 20;
  constexpr uint8_t BIN_FREQUENCY_STEP = 100;
  
  constexpr uint16_t N_WAVE = 4096; // full length of Sinewave[]
  constexpr uint8_t  LOG2_N_WAVE = 12; // log2(N_WAVE)
  
  void enable();
  void disable();
  float record(float bins[]);
  float soundPressureLevel(float rawAdcVal);
  uint32_t GetSampleRateDelay(uint16_t sampleRate);
  float GetSampleTimeNoDelay(void);
  float sd(int16_t *data, uint16_t len);
  
  /*
    fix_fft() - perform forward/inverse fast Fourier transform.
    fr[n],fi[n] are real and imaginary arrays, both INPUT AND
    RESULT (in-place FFT), with 0 <= n < 2**m; set inverse to
    0 for forward transform (FFT), or 1 for iFFT.
  */
  int32_t fix_fft(int16_t fr[], int16_t fi[], int16_t m, int16_t inverse);
  
  constexpr int16_t Sinewave[N_WAVE-N_WAVE/4] = {
        0,     50,    101,    151,    201,    251,    302,    352,    402,    452,    503,    553,    603,    653,    704,    754,    804, 
      854,    905,    955,   1005,   1055,   1106,   1156,   1206,   1256,   1307,   1357,   1407,   1457,   1507,   1558,   1608,   1658,
     1708,   1758,   1809,   1859,   1909,   1959,   2009,   2059,   2110,   2160,   2210,   2260,   2310,   2360,   2410,   2461,   2511,
     2561,   2611,   2661,   2711,   2761,   2811,   2861,   2911,   2962,   3012,   3062,   3112,   3162,   3212,   3262,   3312,   3362,
     3412,   3462,   3512,   3562,   3612,   3662,   3712,   3761,   3811,   3861,   3911,   3961,   4011,   4061,   4111,   4161,   4210,
     4260,   4310,   4360,   4410,   4460,   4509,   4559,   4609,   4659,   4708,   4758,   4808,   4858,   4907,   4957,   5007,   5056,
     5106,   5156,   5205,   5255,   5305,   5354,   5404,   5453,   5503,   5552,   5602,   5651,   5701,   5750,   5800,   5849,   5899,
     5948,   5998,   6047,   6096,   6146,   6195,   6245,   6294,   6343,   6393,   6442,   6491,   6540,   6590,   6639,   6688,   6737,
     6786,   6836,   6885,   6934,   6983,   7032,   7081,   7130,   7179,   7228,   7277,   7326,   7375,   7424,   7473,   7522,   7571,
     7620,   7669,   7718,   7767,   7815,   7864,   7913,   7962,   8010,   8059,   8108,   8157,   8205,   8254,   8303,   8351,   8400,
     8448,   8497,   8545,   8594,   8642,   8691,   8739,   8788,   8836,   8885,   8933,   8981,   9030,   9078,   9126,   9175,   9223,
     9271,   9319,   9367,   9416,   9464,   9512,   9560,   9608,   9656,   9704,   9752,   9800,   9848,   9896,   9944,   9992,  10039,
    10087,  10135,  10183,  10231,  10278,  10326,  10374,  10421,  10469,  10517,  10564,  10612,  10659,  10707,  10754,  10802,  10849,
    10897,  10944,  10992,  11039,  11086,  11133,  11181,  11228,  11275,  11322,  11370,  11417,  11464,  11511,  11558,  11605,  11652,
    11699,  11746,  11793,  11840,  11886,  11933,  11980,  12027,  12074,  12120,  12167,  12214,  12260,  12307,  12353,  12400,  12446,
    12493,  12539,  12586,  12632,  12679,  12725,  12771,  12817,  12864,  12910,  12956,  13002,  13048,  13094,  13141,  13187,  13233,
    13279,  13324,  13370,  13416,  13462,  13508,  13554,  13599,  13645,  13691,  13736,  13782,  13828,  13873,  13919,  13964,  14010,
    14055,  14101,  14146,  14191,  14236,  14282,  14327,  14372,  14417,  14462,  14507,  14553,  14598,  14643,  14688,  14732,  14777,
    14822,  14867,  14912,  14956,  15001,  15046,  15090,  15135,  15180,  15224,  15269,  15313,  15358,  15402,  15446,  15491,  15535,
    15579,  15623,  15667,  15712,  15756,  15800,  15844,  15888,  15932,  15976,  16019,  16063,  16107,  16151,  16195,  16238,  16282,
    16325,  16369,  16413,  16456,  16499,  16543,  16586,  16630,  16673,  16716,  16759,  16802,  16846,  16889,  16932,  16975,  17018,
    17061,  17104,  17146,  17189,  17232,  17275,  17317,  17360,  17403,  17445,  17488,  17530,  17573,  17615,  17657,  17700,  17742,
    17784,  17827,  17869,  17911,  17953,  17995,  18037,  18079,  18121,  18163,  18204,  18246,  18288,  18330,  18371,  18413,  18454,
    18496,  18537,  18579,  18620,  18661,  18703,  18744,  18785,  18826,  18868,  18909,  18950,  18991,  19032,  19072,  19113,  19154,
    19195,  19236,  19276,  19317,  19357,  19398,  19438,  19479,  19519,  19560,  19600,  19640,  19680,  19721,  19761,  19801,  19841,
    19881,  19921,  19961,  20000,  20040,  20080,  20120,  20159,  20199,  20238,  20278,  20317,  20357,  20396,  20436,  20475,  20514,
    20553,  20592,  20631,  20670,  20709,  20748,  20787,  20826,  20865,  20904,  20942,  20981,  21019,  21058,  21096,  21135,  21173,
    21212,  21250,  21288,  21326,  21364,  21403,  21441,  21479,  21516,  21554,  21592,  21630,  21668,  21705,  21743,  21781,  21818,
    21856,  21893,  21930,  21968,  22005,  22042,  22079,  22116,  22154,  22191,  22227,  22264,  22301,  22338,  22375,  22411,  22448,
    22485,  22521,  22558,  22594,  22631,  22667,  22703,  22739,  22776,  22812,  22848,  22884,  22920,  22956,  22991,  23027,  23063,
    23099,  23134,  23170,  23205,  23241,  23276,  23311,  23347,  23382,  23417,  23452,  23487,  23522,  23557,  23592,  23627,  23662,
    23697,  23731,  23766,  23801,  23835,  23870,  23904,  23938,  23973,  24007,  24041,  24075,  24109,  24143,  24177,  24211,  24245,
    24279,  24312,  24346,  24380,  24413,  24447,  24480,  24514,  24547,  24580,  24613,  24647,  24680,  24713,  24746,  24779,  24811,
    24844,  24877,  24910,  24942,  24975,  25007,  25040,  25072,  25105,  25137,  25169,  25201,  25233,  25265,  25297,  25329,  25361,
    25393,  25425,  25456,  25488,  25519,  25551,  25582,  25614,  25645,  25676,  25708,  25739,  25770,  25801,  25832,  25863,  25893,
    25924,  25955,  25986,  26016,  26047,  26077,  26108,  26138,  26168,  26198,  26229,  26259,  26289,  26319,  26349,  26378,  26408,
    26438,  26468,  26497,  26527,  26556,  26586,  26615,  26644,  26674,  26703,  26732,  26761,  26790,  26819,  26848,  26876,  26905,
    26934,  26962,  26991,  27019,  27048,  27076,  27104,  27133,  27161,  27189,  27217,  27245,  27273,  27300,  27328,  27356,  27384,
    27411,  27439,  27466,  27493,  27521,  27548,  27575,  27602,  27629,  27656,  27683,  27710,  27737,  27764,  27790,  27817,  27843,
    27870,  27896,  27923,  27949,  27975,  28001,  28027,  28053,  28079,  28105,  28131,  28157,  28182,  28208,  28234,  28259,  28284,
    28310,  28335,  28360,  28385,  28411,  28436,  28460,  28485,  28510,  28535,  28560,  28584,  28609,  28633,  28658,  28682,  28706,
    28730,  28755,  28779,  28803,  28827,  28850,  28874,  28898,  28922,  28945,  28969,  28992,  29016,  29039,  29062,  29085,  29108,
    29131,  29154,  29177,  29200,  29223,  29246,  29268,  29291,  29313,  29336,  29358,  29380,  29403,  29425,  29447,  29469,  29491,
    29513,  29534,  29556,  29578,  29599,  29621,  29642,  29664,  29685,  29706,  29728,  29749,  29770,  29791,  29812,  29832,  29853,
    29874,  29894,  29915,  29936,  29956,  29976,  29997,  30017,  30037,  30057,  30077,  30097,  30117,  30136,  30156,  30176,  30195,
    30215,  30234,  30253,  30273,  30292,  30311,  30330,  30349,  30368,  30387,  30406,  30424,  30443,  30462,  30480,  30498,  30517,
    30535,  30553,  30571,  30589,  30607,  30625,  30643,  30661,  30679,  30696,  30714,  30731,  30749,  30766,  30783,  30800,  30818,
    30835,  30852,  30868,  30885,  30902,  30919,  30935,  30952,  30968,  30985,  31001,  31017,  31033,  31050,  31066,  31082,  31097,
    31113,  31129,  31145,  31160,  31176,  31191,  31206,  31222,  31237,  31252,  31267,  31282,  31297,  31312,  31327,  31341,  31356,
    31371,  31385,  31400,  31414,  31428,  31442,  31456,  31470,  31484,  31498,  31512,  31526,  31539,  31553,  31567,  31580,  31593,
    31607,  31620,  31633,  31646,  31659,  31672,  31685,  31698,  31710,  31723,  31736,  31748,  31760,  31773,  31785,  31797,  31809,
    31821,  31833,  31845,  31857,  31869,  31880,  31892,  31903,  31915,  31926,  31937,  31949,  31960,  31971,  31982,  31993,  32004,
    32014,  32025,  32036,  32046,  32057,  32067,  32077,  32087,  32098,  32108,  32118,  32128,  32137,  32147,  32157,  32166,  32176,
    32185,  32195,  32204,  32213,  32223,  32232,  32241,  32250,  32258,  32267,  32276,  32285,  32293,  32302,  32310,  32318,  32327,
    32335,  32343,  32351,  32359,  32367,  32375,  32382,  32390,  32397,  32405,  32412,  32420,  32427,  32434,  32441,  32448,  32455,
    32462,  32469,  32476,  32482,  32489,  32495,  32502,  32508,  32514,  32521,  32527,  32533,  32539,  32545,  32550,  32556,  32562,
    32567,  32573,  32578,  32584,  32589,  32594,  32599,  32604,  32609,  32614,  32619,  32624,  32628,  32633,  32637,  32642,  32646,
    32650,  32655,  32659,  32663,  32667,  32671,  32674,  32678,  32682,  32685,  32689,  32692,  32696,  32699,  32702,  32705,  32708,
    32711,  32714,  32717,  32720,  32722,  32725,  32728,  32730,  32732,  32735,  32737,  32739,  32741,  32743,  32745,  32747,  32748,
    32750,  32752,  32753,  32755,  32756,  32757,  32758,  32759,  32760,  32761,  32762,  32763,  32764,  32765,  32765,  32766,  32766,
    32766,  32767,  32767,  32767,  32767,  32767,  32767,  32767,  32766,  32766,  32766,  32765,  32765,  32764,  32763,  32762,  32761,
    32760,  32759,  32758,  32757,  32756,  32755,  32753,  32752,  32750,  32748,  32747,  32745,  32743,  32741,  32739,  32737,  32735,
    32732,  32730,  32728,  32725,  32722,  32720,  32717,  32714,  32711,  32708,  32705,  32702,  32699,  32696,  32692,  32689,  32685,
    32682,  32678,  32674,  32671,  32667,  32663,  32659,  32655,  32650,  32646,  32642,  32637,  32633,  32628,  32624,  32619,  32614,
    32609,  32604,  32599,  32594,  32589,  32584,  32578,  32573,  32567,  32562,  32556,  32550,  32545,  32539,  32533,  32527,  32521,
    32514,  32508,  32502,  32495,  32489,  32482,  32476,  32469,  32462,  32455,  32448,  32441,  32434,  32427,  32420,  32412,  32405,
    32397,  32390,  32382,  32375,  32367,  32359,  32351,  32343,  32335,  32327,  32318,  32310,  32302,  32293,  32285,  32276,  32267,
    32258,  32250,  32241,  32232,  32223,  32213,  32204,  32195,  32185,  32176,  32166,  32157,  32147,  32137,  32128,  32118,  32108,
    32098,  32087,  32077,  32067,  32057,  32046,  32036,  32025,  32014,  32004,  31993,  31982,  31971,  31960,  31949,  31937,  31926,
    31915,  31903,  31892,  31880,  31869,  31857,  31845,  31833,  31821,  31809,  31797,  31785,  31773,  31760,  31748,  31736,  31723,
    31710,  31698,  31685,  31672,  31659,  31646,  31633,  31620,  31607,  31593,  31580,  31567,  31553,  31539,  31526,  31512,  31498,
    31484,  31470,  31456,  31442,  31428,  31414,  31400,  31385,  31371,  31356,  31341,  31327,  31312,  31297,  31282,  31267,  31252,
    31237,  31222,  31206,  31191,  31176,  31160,  31145,  31129,  31113,  31097,  31082,  31066,  31050,  31033,  31017,  31001,  30985,
    30968,  30952,  30935,  30919,  30902,  30885,  30868,  30852,  30835,  30818,  30800,  30783,  30766,  30749,  30731,  30714,  30696,
    30679,  30661,  30643,  30625,  30607,  30589,  30571,  30553,  30535,  30517,  30498,  30480,  30462,  30443,  30424,  30406,  30387,
    30368,  30349,  30330,  30311,  30292,  30273,  30253,  30234,  30215,  30195,  30176,  30156,  30136,  30117,  30097,  30077,  30057,
    30037,  30017,  29997,  29976,  29956,  29936,  29915,  29894,  29874,  29853,  29832,  29812,  29791,  29770,  29749,  29728,  29706,
    29685,  29664,  29642,  29621,  29599,  29578,  29556,  29534,  29513,  29491,  29469,  29447,  29425,  29403,  29380,  29358,  29336,
    29313,  29291,  29268,  29246,  29223,  29200,  29177,  29154,  29131,  29108,  29085,  29062,  29039,  29016,  28992,  28969,  28945,
    28922,  28898,  28874,  28850,  28827,  28803,  28779,  28755,  28730,  28706,  28682,  28658,  28633,  28609,  28584,  28560,  28535,
    28510,  28485,  28460,  28436,  28411,  28385,  28360,  28335,  28310,  28284,  28259,  28234,  28208,  28182,  28157,  28131,  28105,
    28079,  28053,  28027,  28001,  27975,  27949,  27923,  27896,  27870,  27843,  27817,  27790,  27764,  27737,  27710,  27683,  27656,
    27629,  27602,  27575,  27548,  27521,  27493,  27466,  27439,  27411,  27384,  27356,  27328,  27300,  27273,  27245,  27217,  27189,
    27161,  27133,  27104,  27076,  27048,  27019,  26991,  26962,  26934,  26905,  26876,  26848,  26819,  26790,  26761,  26732,  26703,
    26674,  26644,  26615,  26586,  26556,  26527,  26497,  26468,  26438,  26408,  26378,  26349,  26319,  26289,  26259,  26229,  26198,
    26168,  26138,  26108,  26077,  26047,  26016,  25986,  25955,  25924,  25893,  25863,  25832,  25801,  25770,  25739,  25708,  25676,
    25645,  25614,  25582,  25551,  25519,  25488,  25456,  25425,  25393,  25361,  25329,  25297,  25265,  25233,  25201,  25169,  25137,
    25105,  25072,  25040,  25007,  24975,  24942,  24910,  24877,  24844,  24811,  24779,  24746,  24713,  24680,  24647,  24613,  24580,
    24547,  24514,  24480,  24447,  24413,  24380,  24346,  24312,  24279,  24245,  24211,  24177,  24143,  24109,  24075,  24041,  24007,
    23973,  23938,  23904,  23870,  23835,  23801,  23766,  23731,  23697,  23662,  23627,  23592,  23557,  23522,  23487,  23452,  23417,
    23382,  23347,  23311,  23276,  23241,  23205,  23170,  23134,  23099,  23063,  23027,  22991,  22956,  22920,  22884,  22848,  22812,
    22776,  22739,  22703,  22667,  22631,  22594,  22558,  22521,  22485,  22448,  22411,  22375,  22338,  22301,  22264,  22227,  22191,
    22154,  22116,  22079,  22042,  22005,  21968,  21930,  21893,  21856,  21818,  21781,  21743,  21705,  21668,  21630,  21592,  21554,
    21516,  21479,  21441,  21403,  21364,  21326,  21288,  21250,  21212,  21173,  21135,  21096,  21058,  21019,  20981,  20942,  20904,
    20865,  20826,  20787,  20748,  20709,  20670,  20631,  20592,  20553,  20514,  20475,  20436,  20396,  20357,  20317,  20278,  20238,
    20199,  20159,  20120,  20080,  20040,  20000,  19961,  19921,  19881,  19841,  19801,  19761,  19721,  19680,  19640,  19600,  19560,
    19519,  19479,  19438,  19398,  19357,  19317,  19276,  19236,  19195,  19154,  19113,  19072,  19032,  18991,  18950,  18909,  18868,
    18826,  18785,  18744,  18703,  18661,  18620,  18579,  18537,  18496,  18454,  18413,  18371,  18330,  18288,  18246,  18204,  18163,
    18121,  18079,  18037,  17995,  17953,  17911,  17869,  17827,  17784,  17742,  17700,  17657,  17615,  17573,  17530,  17488,  17445,
    17403,  17360,  17317,  17275,  17232,  17189,  17146,  17104,  17061,  17018,  16975,  16932,  16889,  16846,  16802,  16759,  16716,
    16673,  16630,  16586,  16543,  16499,  16456,  16413,  16369,  16325,  16282,  16238,  16195,  16151,  16107,  16063,  16019,  15976,
    15932,  15888,  15844,  15800,  15756,  15712,  15667,  15623,  15579,  15535,  15491,  15446,  15402,  15358,  15313,  15269,  15224,
    15180,  15135,  15090,  15046,  15001,  14956,  14912,  14867,  14822,  14777,  14732,  14688,  14643,  14598,  14553,  14507,  14462,
    14417,  14372,  14327,  14282,  14236,  14191,  14146,  14101,  14055,  14010,  13964,  13919,  13873,  13828,  13782,  13736,  13691,
    13645,  13599,  13554,  13508,  13462,  13416,  13370,  13324,  13279,  13233,  13187,  13141,  13094,  13048,  13002,  12956,  12910,
    12864,  12817,  12771,  12725,  12679,  12632,  12586,  12539,  12493,  12446,  12400,  12353,  12307,  12260,  12214,  12167,  12120,
    12074,  12027,  11980,  11933,  11886,  11840,  11793,  11746,  11699,  11652,  11605,  11558,  11511,  11464,  11417,  11370,  11322,
    11275,  11228,  11181,  11133,  11086,  11039,  10992,  10944,  10897,  10849,  10802,  10754,  10707,  10659,  10612,  10564,  10517,
    10469,  10421,  10374,  10326,  10278,  10231,  10183,  10135,  10087,  10039,   9992,   9944,   9896,   9848,   9800,   9752,   9704,
     9656,   9608,   9560,   9512,   9464,   9416,   9367,   9319,   9271,   9223,   9175,   9126,   9078,   9030,   8981,   8933,   8885,
     8836,   8788,   8739,   8691,   8642,   8594,   8545,   8497,   8448,   8400,   8351,   8303,   8254,   8205,   8157,   8108,   8059,
     8010,   7962,   7913,   7864,   7815,   7767,   7718,   7669,   7620,   7571,   7522,   7473,   7424,   7375,   7326,   7277,   7228,
     7179,   7130,   7081,   7032,   6983,   6934,   6885,   6836,   6786,   6737,   6688,   6639,   6590,   6540,   6491,   6442,   6393,
     6343,   6294,   6245,   6195,   6146,   6096,   6047,   5998,   5948,   5899,   5849,   5800,   5750,   5701,   5651,   5602,   5552,
     5503,   5453,   5404,   5354,   5305,   5255,   5205,   5156,   5106,   5056,   5007,   4957,   4907,   4858,   4808,   4758,   4708,
     4659,   4609,   4559,   4509,   4460,   4410,   4360,   4310,   4260,   4210,   4161,   4111,   4061,   4011,   3961,   3911,   3861,
     3811,   3761,   3712,   3662,   3612,   3562,   3512,   3462,   3412,   3362,   3312,   3262,   3212,   3162,   3112,   3062,   3012,
     2962,   2911,   2861,   2811,   2761,   2711,   2661,   2611,   2561,   2511,   2461,   2410,   2360,   2310,   2260,   2210,   2160,
     2110,   2059,   2009,   1959,   1909,   1859,   1809,   1758,   1708,   1658,   1608,   1558,   1507,   1457,   1407,   1357,   1307,
     1256,   1206,   1156,   1106,   1055,   1005,    955,    905,    854,    804,    754,    704,    653,    603,    553,    503,    452,
      402,    352,    302,    251,    201,    151,    101,     50,      0,    -50,   -101,   -151,   -201,   -251,   -302,   -352,   -402,
     -452,   -503,   -553,   -603,   -653,   -704,   -754,   -804,   -854,   -905,   -955,  -1005,  -1055,  -1106,  -1156,  -1206,  -1256,
    -1307,  -1357,  -1407,  -1457,  -1507,  -1558,  -1608,  -1658,  -1708,  -1758,  -1809,  -1859,  -1909,  -1959,  -2009,  -2059,  -2110,
    -2160,  -2210,  -2260,  -2310,  -2360,  -2410,  -2461,  -2511,  -2561,  -2611,  -2661,  -2711,  -2761,  -2811,  -2861,  -2911,  -2962,
    -3012,  -3062,  -3112,  -3162,  -3212,  -3262,  -3312,  -3362,  -3412,  -3462,  -3512,  -3562,  -3612,  -3662,  -3712,  -3761,  -3811,
    -3861,  -3911,  -3961,  -4011,  -4061,  -4111,  -4161,  -4210,  -4260,  -4310,  -4360,  -4410,  -4460,  -4509,  -4559,  -4609,  -4659,
    -4708,  -4758,  -4808,  -4858,  -4907,  -4957,  -5007,  -5056,  -5106,  -5156,  -5205,  -5255,  -5305,  -5354,  -5404,  -5453,  -5503,
    -5552,  -5602,  -5651,  -5701,  -5750,  -5800,  -5849,  -5899,  -5948,  -5998,  -6047,  -6096,  -6146,  -6195,  -6245,  -6294,  -6343,
    -6393,  -6442,  -6491,  -6540,  -6590,  -6639,  -6688,  -6737,  -6786,  -6836,  -6885,  -6934,  -6983,  -7032,  -7081,  -7130,  -7179,
    -7228,  -7277,  -7326,  -7375,  -7424,  -7473,  -7522,  -7571,  -7620,  -7669,  -7718,  -7767,  -7815,  -7864,  -7913,  -7962,  -8010,
    -8059,  -8108,  -8157,  -8205,  -8254,  -8303,  -8351,  -8400,  -8448,  -8497,  -8545,  -8594,  -8642,  -8691,  -8739,  -8788,  -8836,
    -8885,  -8933,  -8981,  -9030,  -9078,  -9126,  -9175,  -9223,  -9271,  -9319,  -9367,  -9416,  -9464,  -9512,  -9560,  -9608,  -9656,
    -9704,  -9752,  -9800,  -9848,  -9896,  -9944,  -9992, -10039, -10087, -10135, -10183, -10231, -10278, -10326, -10374, -10421, -10469,
   -10517, -10564, -10612, -10659, -10707, -10754, -10802, -10849, -10897, -10944, -10992, -11039, -11086, -11133, -11181, -11228, -11275,
   -11322, -11370, -11417, -11464, -11511, -11558, -11605, -11652, -11699, -11746, -11793, -11840, -11886, -11933, -11980, -12027, -12074,
   -12120, -12167, -12214, -12260, -12307, -12353, -12400, -12446, -12493, -12539, -12586, -12632, -12679, -12725, -12771, -12817, -12864,
   -12910, -12956, -13002, -13048, -13094, -13141, -13187, -13233, -13279, -13324, -13370, -13416, -13462, -13508, -13554, -13599, -13645,
   -13691, -13736, -13782, -13828, -13873, -13919, -13964, -14010, -14055, -14101, -14146, -14191, -14236, -14282, -14327, -14372, -14417,
   -14462, -14507, -14553, -14598, -14643, -14688, -14732, -14777, -14822, -14867, -14912, -14956, -15001, -15046, -15090, -15135, -15180,
   -15224, -15269, -15313, -15358, -15402, -15446, -15491, -15535, -15579, -15623, -15667, -15712, -15756, -15800, -15844, -15888, -15932,
   -15976, -16019, -16063, -16107, -16151, -16195, -16238, -16282, -16325, -16369, -16413, -16456, -16499, -16543, -16586, -16630, -16673,
   -16716, -16759, -16802, -16846, -16889, -16932, -16975, -17018, -17061, -17104, -17146, -17189, -17232, -17275, -17317, -17360, -17403,
   -17445, -17488, -17530, -17573, -17615, -17657, -17700, -17742, -17784, -17827, -17869, -17911, -17953, -17995, -18037, -18079, -18121,
   -18163, -18204, -18246, -18288, -18330, -18371, -18413, -18454, -18496, -18537, -18579, -18620, -18661, -18703, -18744, -18785, -18826,
   -18868, -18909, -18950, -18991, -19032, -19072, -19113, -19154, -19195, -19236, -19276, -19317, -19357, -19398, -19438, -19479, -19519,
   -19560, -19600, -19640, -19680, -19721, -19761, -19801, -19841, -19881, -19921, -19961, -20000, -20040, -20080, -20120, -20159, -20199,
   -20238, -20278, -20317, -20357, -20396, -20436, -20475, -20514, -20553, -20592, -20631, -20670, -20709, -20748, -20787, -20826, -20865,
   -20904, -20942, -20981, -21019, -21058, -21096, -21135, -21173, -21212, -21250, -21288, -21326, -21364, -21403, -21441, -21479, -21516,
   -21554, -21592, -21630, -21668, -21705, -21743, -21781, -21818, -21856, -21893, -21930, -21968, -22005, -22042, -22079, -22116, -22154,
   -22191, -22227, -22264, -22301, -22338, -22375, -22411, -22448, -22485, -22521, -22558, -22594, -22631, -22667, -22703, -22739, -22776,
   -22812, -22848, -22884, -22920, -22956, -22991, -23027, -23063, -23099, -23134, -23170, -23205, -23241, -23276, -23311, -23347, -23382,
   -23417, -23452, -23487, -23522, -23557, -23592, -23627, -23662, -23697, -23731, -23766, -23801, -23835, -23870, -23904, -23938, -23973,
   -24007, -24041, -24075, -24109, -24143, -24177, -24211, -24245, -24279, -24312, -24346, -24380, -24413, -24447, -24480, -24514, -24547,
   -24580, -24613, -24647, -24680, -24713, -24746, -24779, -24811, -24844, -24877, -24910, -24942, -24975, -25007, -25040, -25072, -25105,
   -25137, -25169, -25201, -25233, -25265, -25297, -25329, -25361, -25393, -25425, -25456, -25488, -25519, -25551, -25582, -25614, -25645,
   -25676, -25708, -25739, -25770, -25801, -25832, -25863, -25893, -25924, -25955, -25986, -26016, -26047, -26077, -26108, -26138, -26168,
   -26198, -26229, -26259, -26289, -26319, -26349, -26378, -26408, -26438, -26468, -26497, -26527, -26556, -26586, -26615, -26644, -26674,
   -26703, -26732, -26761, -26790, -26819, -26848, -26876, -26905, -26934, -26962, -26991, -27019, -27048, -27076, -27104, -27133, -27161,
   -27189, -27217, -27245, -27273, -27300, -27328, -27356, -27384, -27411, -27439, -27466, -27493, -27521, -27548, -27575, -27602, -27629,
   -27656, -27683, -27710, -27737, -27764, -27790, -27817, -27843, -27870, -27896, -27923, -27949, -27975, -28001, -28027, -28053, -28079,
   -28105, -28131, -28157, -28182, -28208, -28234, -28259, -28284, -28310, -28335, -28360, -28385, -28411, -28436, -28460, -28485, -28510,
   -28535, -28560, -28584, -28609, -28633, -28658, -28682, -28706, -28730, -28755, -28779, -28803, -28827, -28850, -28874, -28898, -28922,
   -28945, -28969, -28992, -29016, -29039, -29062, -29085, -29108, -29131, -29154, -29177, -29200, -29223, -29246, -29268, -29291, -29313,
   -29336, -29358, -29380, -29403, -29425, -29447, -29469, -29491, -29513, -29534, -29556, -29578, -29599, -29621, -29642, -29664, -29685,
   -29706, -29728, -29749, -29770, -29791, -29812, -29832, -29853, -29874, -29894, -29915, -29936, -29956, -29976, -29997, -30017, -30037,
   -30057, -30077, -30097, -30117, -30136, -30156, -30176, -30195, -30215, -30234, -30253, -30273, -30292, -30311, -30330, -30349, -30368,
   -30387, -30406, -30424, -30443, -30462, -30480, -30498, -30517, -30535, -30553, -30571, -30589, -30607, -30625, -30643, -30661, -30679,
   -30696, -30714, -30731, -30749, -30766, -30783, -30800, -30818, -30835, -30852, -30868, -30885, -30902, -30919, -30935, -30952, -30968,
   -30985, -31001, -31017, -31033, -31050, -31066, -31082, -31097, -31113, -31129, -31145, -31160, -31176, -31191, -31206, -31222, -31237,
   -31252, -31267, -31282, -31297, -31312, -31327, -31341, -31356, -31371, -31385, -31400, -31414, -31428, -31442, -31456, -31470, -31484,
   -31498, -31512, -31526, -31539, -31553, -31567, -31580, -31593, -31607, -31620, -31633, -31646, -31659, -31672, -31685, -31698, -31710,
   -31723, -31736, -31748, -31760, -31773, -31785, -31797, -31809, -31821, -31833, -31845, -31857, -31869, -31880, -31892, -31903, -31915,
   -31926, -31937, -31949, -31960, -31971, -31982, -31993, -32004, -32014, -32025, -32036, -32046, -32057, -32067, -32077, -32087, -32098,
   -32108, -32118, -32128, -32137, -32147, -32157, -32166, -32176, -32185, -32195, -32204, -32213, -32223, -32232, -32241, -32250, -32258,
   -32267, -32276, -32285, -32293, -32302, -32310, -32318, -32327, -32335, -32343, -32351, -32359, -32367, -32375, -32382, -32390, -32397,
   -32405, -32412, -32420, -32427, -32434, -32441, -32448, -32455, -32462, -32469, -32476, -32482, -32489, -32495, -32502, -32508, -32514,
   -32521, -32527, -32533, -32539, -32545, -32550, -32556, -32562, -32567, -32573, -32578, -32584, -32589, -32594, -32599, -32604, -32609,
   -32614, -32619, -32624, -32628, -32633, -32637, -32642, -32646, -32650, -32655, -32659, -32663, -32667, -32671, -32674, -32678, -32682,
   -32685, -32689, -32692, -32696, -32699, -32702, -32705, -32708, -32711, -32714, -32717, -32720, -32722, -32725, -32728, -32730, -32732,
   -32735, -32737, -32739, -32741, -32743, -32745, -32747, -32748, -32750, -32752, -32753, -32755, -32756, -32757, -32758, -32759, -32760,
   -32761, -32762, -32763, -32764, -32765, -32765, -32766, -32766, -32766, -32767, -32767, -32767,
  };
}

#endif
